home *** CD-ROM | disk | FTP | other *** search
/ PC World Komputer 2010 April / PCWorld0410.iso / hity wydania / Ubuntu 9.10 PL / karmelkowy-koliberek-desktop-9.10-i386-PL.iso / casper / filesystem.squashfs / var / lib / dpkg / info / xfonts-base.postrm < prev    next >
Text File  |  2009-04-29  |  29KB  |  900 lines

  1. #!/bin/sh
  2. # Debian xfonts-base package post-removal script
  3. # Copyright ┬⌐ 1998-2001, 2004 Branden Robinson
  4. # Licensed under the GNU General Public License, version 2.  See the file
  5. # /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
  6. # Acknowledgements to Stephen Early, Mark Eichin, and Manoj Srivastava.
  7.  
  8. set -e
  9.  
  10. THIS_PACKAGE=xfonts-base
  11. THIS_SCRIPT=postrm
  12.  
  13. # $Id$
  14.  
  15. # This is the X Strike Force shell library for X Window System package
  16. # maintainer scripts.  It serves to define shell functions commonly used by
  17. # such packages, and performs some error checking necessary for proper operation
  18. # of those functions.  By itself, it does not "do" much; the maintainer scripts
  19. # invoke the functions defined here to accomplish package installation and
  20. # removal tasks.
  21.  
  22. # If you are reading this within a Debian package maintainer script (e.g.,
  23. # /var/lib/dpkg)info/PACKAGE.{config,preinst,postinst,prerm,postrm}), you can
  24. # skip past this library by scanning forward in this file to the string
  25. # "GOBSTOPPER".
  26.  
  27. SOURCE_VERSION=1:1.0.0-6
  28. OFFICIAL_BUILD=yes
  29.  
  30. # Use special abnormal exit codes so that problems with this library are more
  31. # easily tracked down.
  32. SHELL_LIB_INTERNAL_ERROR=86
  33. SHELL_LIB_THROWN_ERROR=74
  34. SHELL_LIB_USAGE_ERROR=99
  35.  
  36. # old -> new variable names
  37. if [ -z "$DEBUG_XORG_PACKAGE" ] && [ -n "$DEBUG_XFREE86_PACKAGE" ]; then
  38.   DEBUG_XORG_PACKAGE="$DEBUG_XFREE86_PACKAGE"
  39. fi
  40. if [ -z "$DEBUG_XORG_DEBCONF" ] && [ -n "$DEBUG_XFREE86_DEBCONF" ]; then
  41.   DEBUG_XORG_DEBCONF="$DEBUG_XFREE86_DEBCONF"
  42. fi
  43.  
  44. # initial sanity checks
  45. if [ -z "$THIS_PACKAGE" ]; then
  46.   cat >&2 <<EOF
  47. Error: package maintainer script attempted to use shell library without
  48. definining \$THIS_PACKAGE shell variable.  Please report the package name,
  49. version, and the text of this error message to the Debian Bug Tracking System.
  50. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  51. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  52. "doc-debian" package, or install the "reportbug" package and use the command of
  53. the same name to file a report against version $SOURCE_VERSION of this package.
  54. EOF
  55.   exit $SHELL_LIB_USAGE_ERROR
  56. fi
  57.  
  58. if [ -z "$THIS_SCRIPT" ]; then
  59.   cat >&2 <<EOF
  60. Error: package maintainer script attempted to use shell library without
  61. definining \$THIS_SCRIPT shell variable.  Please report the package name,
  62. version, and the text of this error message to the Debian Bug Tracking System.
  63. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  64. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  65. "doc-debian" package, or install the "reportbug" package and use the command of
  66. the same name to file a report against version $SOURCE_VERSION of the
  67. "$THIS_PACKAGE" package.
  68. EOF
  69.   exit $SHELL_LIB_USAGE_ERROR
  70. fi
  71.  
  72. ARCHITECTURE="$(dpkg --print-installation-architecture)"
  73.  
  74. if [ "$1" = "reconfigure" ] || [ -n "$DEBCONF_RECONFIGURE" ]; then
  75.   RECONFIGURE="true"
  76. else
  77.   RECONFIGURE=
  78. fi
  79.  
  80. if ([ "$1" = "install" ] || [ "$1" = "configure" ]) && [ -z "$2" ]; then
  81.   FIRSTINST="yes"
  82. fi
  83.  
  84. if [ -z "$RECONFIGURE" ] && [ -z "$FIRSTINST" ]; then
  85.   UPGRADE="yes"
  86. fi
  87.  
  88. trap "message;\
  89.       message \"Received signal.  Aborting $THIS_PACKAGE package $THIS_SCRIPT script.\";\
  90.       message;\
  91.       exit 1" HUP INT QUIT TERM
  92.  
  93. reject_nondigits () {
  94.   # syntax: reject_nondigits [ operand ... ]
  95.   #
  96.   # scan operands (typically shell variables whose values cannot be trusted) for
  97.   # characters other than decimal digits and barf if any are found
  98.   while [ -n "$1" ]; do
  99.     # does the operand contain anything but digits?
  100.     if ! expr "$1" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  101.       # can't use die(), because it wraps message() which wraps this function
  102.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_nondigits() encountered" \
  103.            "possibly malicious garbage \"$1\"" >&2
  104.       exit $SHELL_LIB_THROWN_ERROR
  105.     fi
  106.     shift
  107.   done
  108. }
  109.  
  110. reject_whitespace () {
  111.   # syntax: reject_whitespace [ operand ]
  112.   #
  113.   # scan operand (typically a shell variable whose value cannot be trusted) for
  114.   # whitespace characters and barf if any are found
  115.   if [ -n "$1" ]; then
  116.     # does the operand contain any whitespace?
  117.     if expr "$1" : "[[:space:]]" > /dev/null 2>&1; then
  118.       # can't use die(), because I want to avoid forward references
  119.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_whitespace() encountered" \
  120.            "possibly malicious garbage \"$1\"" >&2
  121.       exit $SHELL_LIB_THROWN_ERROR
  122.     fi
  123.   fi
  124. }
  125.  
  126. reject_unlikely_path_chars () {
  127.   # syntax: reject_unlikely_path_chars [ operand ... ]
  128.   #
  129.   # scan operands (typically shell variables whose values cannot be trusted) for
  130.   # characters unlikely to be seen in a path and which the shell might
  131.   # interpret and barf if any are found
  132.   while [ -n "$1" ]; do
  133.     # does the operand contain any funny characters?
  134.     if expr "$1" : '.*[!$&()*;<>?|].*' > /dev/null 2>&1; then
  135.       # can't use die(), because I want to avoid forward references
  136.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_unlikely_path_chars()" \
  137.            "encountered possibly malicious garbage \"$1\"" >&2
  138.       exit $SHELL_LIB_THROWN_ERROR
  139.     fi
  140.     shift
  141.   done
  142. }
  143.  
  144. # Query the terminal to establish a default number of columns to use for
  145. # displaying messages to the user.  This is used only as a fallback in the
  146. # event the COLUMNS variable is not set.  ($COLUMNS can react to SIGWINCH while
  147. # the script is running, and this cannot, only being calculated once.)
  148. DEFCOLUMNS=$(stty size 2> /dev/null | awk '{print $2}') || true
  149. if ! expr "$DEFCOLUMNS" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  150.   DEFCOLUMNS=80
  151. fi
  152.  
  153. message () {
  154.   # pretty-print messages of arbitrary length
  155.   reject_nondigits "$COLUMNS"
  156.   echo "$*" | fmt -t -w ${COLUMNS:-$DEFCOLUMNS} >&2
  157. }
  158.  
  159. observe () {
  160.   # syntax: observe message ...
  161.   #
  162.   # issue observational message suitable for logging someday when support for
  163.   # it exists in dpkg
  164.   if [ -n "$DEBUG_XORG_PACKAGE" ]; then
  165.     message "$THIS_PACKAGE $THIS_SCRIPT note: $*"
  166.   fi
  167. }
  168.  
  169. warn () {
  170.   # syntax: warn message ...
  171.   #
  172.   # issue warning message suitable for logging someday when support for
  173.   # it exists in dpkg; also send to standard error
  174.   message "$THIS_PACKAGE $THIS_SCRIPT warning: $*"
  175. }
  176.  
  177. die () {
  178.   # syntax: die message ...
  179.   #
  180.   # exit script with error message
  181.   message "$THIS_PACKAGE $THIS_SCRIPT error: $*"
  182.   exit $SHELL_LIB_THROWN_ERROR
  183. }
  184.  
  185. internal_error () {
  186.   # exit script with error; essentially a "THIS SHOULD NEVER HAPPEN" message
  187.   message "internal error: $*"
  188.   if [ -n "$OFFICIAL_BUILD" ]; then
  189.     message "Please report a bug in the $THIS_SCRIPT script of the" \
  190.             "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  191.             "Tracking System.  Include all messages above that mention the" \
  192.             "$THIS_PACKAGE package.  Visit " \
  193.             "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  194.             "instructions, read the file" \
  195.             "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  196.             "package, or install the reportbug package and use the command of" \
  197.             "the same name to file a report."
  198.   fi
  199.   exit $SHELL_LIB_INTERNAL_ERROR
  200. }
  201.  
  202. usage_error () {
  203.   message "usage error: $*"
  204.   message "Please report a bug in the $THIS_SCRIPT script of the" \
  205.           "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  206.           "Tracking System.  Include all messages above that mention the" \
  207.           "$THIS_PACKAGE package.  Visit " \
  208.           "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  209.           "instructions, read the file" \
  210.           "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  211.           "package, or install the reportbug package and use the command of" \
  212.           "the same name to file a report."
  213.   exit $SHELL_LIB_USAGE_ERROR
  214. }
  215.  
  216.  
  217. maplink () {
  218.   # returns what symlink should point to; i.e., what the "sane" answer is
  219.   # Keep this in sync with the debian/*.links files.
  220.   # This is only needed for symlinks to directories.
  221.   #
  222.   # XXX: Most of these look wrong in the X11R7 world and need to be fixed.
  223.   # If we've stopped using this function, fixing it might enable us to re-enable
  224.   # it again and catch more errors.
  225.   case "$1" in
  226.     /etc/X11/xkb/compiled) echo /var/lib/xkb ;;
  227.     /etc/X11/xkb/xkbcomp) echo /usr/X11R6/bin/xkbcomp ;;
  228.     /usr/X11R6/lib/X11/app-defaults) echo /etc/X11/app-defaults ;;
  229.     /usr/X11R6/lib/X11/fs) echo /etc/X11/fs ;;
  230.     /usr/X11R6/lib/X11/lbxproxy) echo /etc/X11/lbxproxy ;;
  231.     /usr/X11R6/lib/X11/proxymngr) echo /etc/X11/proxymngr ;;
  232.     /usr/X11R6/lib/X11/rstart) echo /etc/X11/rstart ;;
  233.     /usr/X11R6/lib/X11/twm) echo /etc/X11/twm ;;
  234.     /usr/X11R6/lib/X11/xdm) echo /etc/X11/xdm ;;
  235.     /usr/X11R6/lib/X11/xinit) echo /etc/X11/xinit ;;
  236.     /usr/X11R6/lib/X11/xkb) echo /etc/X11/xkb ;;
  237.     /usr/X11R6/lib/X11/xserver) echo /etc/X11/xserver ;;
  238.     /usr/X11R6/lib/X11/xsm) echo /etc/X11/xsm ;;
  239.     /usr/bin/X11) echo ../X11R6/bin ;;
  240.     /usr/bin/rstartd) echo ../X11R6/bin/rstartd ;;
  241.     /usr/include/X11) echo ../X11R6/include/X11 ;;
  242.     /usr/lib/X11) echo ../X11R6/lib/X11 ;;
  243.     *) internal_error "maplink() called with unknown path \"$1\"" ;;
  244.   esac
  245. }
  246.  
  247. analyze_path () {
  248.   # given a supplied set of pathnames, break each one up by directory and do an
  249.   # ls -dl on each component, cumulatively; i.e.
  250.   # analyze_path /usr/X11R6/bin -> ls -dl /usr /usr/X11R6 /usr/X11R6/bin
  251.   # Thanks to Randolph Chung for this clever hack.
  252.  
  253.   local f g
  254.  
  255.   while [ -n "$1" ]; do
  256.     reject_whitespace "$1"
  257.     g=
  258.     message "Analyzing $1:"
  259.     for f in $(echo "$1" | tr / \  ); do
  260.       if [ -e /$g$f ]; then
  261.         ls -dl /$g$f /$g$f.dpkg-* 2> /dev/null || true
  262.         g=$g$f/
  263.       else
  264.         message "/$g$f: nonexistent; directory contents of /$g:"
  265.         ls -l /$g
  266.         break
  267.       fi
  268.     done
  269.     shift
  270.   done
  271. }
  272.  
  273. find_culprits () {
  274.   local f p dpkg_info_dir possible_culprits smoking_guns bad_packages package \
  275.     msg
  276.  
  277.   reject_whitespace "$1"
  278.   message "Searching for overlapping packages..."
  279.   dpkg_info_dir=/var/lib/dpkg/info
  280.   if [ -d $dpkg_info_dir ]; then
  281.     if [ "$(echo $dpkg_info_dir/*.list)" != "$dpkg_info_dir/*.list" ]; then
  282.       possible_culprits=$(ls -1 $dpkg_info_dir/*.list | egrep -v \
  283.         "(xbase-clients|x11-common|xfs|xlibs)")
  284.       if [ -n "$possible_culprits" ]; then
  285.         smoking_guns=$(grep -l "$1" $possible_culprits || true)
  286.         if [ -n "$smoking_guns" ]; then
  287.           bad_packages=$(printf "\\n")
  288.           for f in $smoking_guns; do
  289.             # too bad you can't nest parameter expansion voodoo
  290.             p=${f%*.list}      # strip off the trailing ".list"
  291.             package=${p##*/}   # strip off the directories
  292.             bad_packages=$(printf "%s\n%s" "$bad_packages" "$package")
  293.           done
  294.           msg=$(cat <<EOF
  295. The following packages appear to have file overlaps with the X.Org packages;
  296. these packages are either very old, or in violation of Debian Policy.  Try
  297. upgrading each of these packages to the latest available version if possible:
  298. for example, with the command "apt-get install".  If no newer version of a
  299. package is available, you will have to remove it; for example, with the command
  300. "apt-get remove".  If even the latest available version of the package has
  301. this file overlap, please file a bug against that package with the Debian Bug
  302. Tracking System.  You may want to refer the package maintainer to section 12.8
  303. of the Debian Policy manual.
  304. EOF
  305. )
  306.           message "$msg"
  307.           message "The overlapping packages are: $bad_packages"
  308.         else
  309.           message "no overlaps found."
  310.         fi
  311.       fi
  312.     else
  313.       message "cannot search; no matches for $dpkg_info_dir/*.list."
  314.     fi
  315.   else
  316.     message "cannot search; $dpkg_info_dir does not exist."
  317.   fi
  318. }
  319.  
  320. # we require a readlink command or shell function
  321. if ! which readlink > /dev/null 2>&1; then
  322.   message "The readlink command was not found.  Please install version" \
  323.           "1.13.1 or later of the debianutils package."
  324.   readlink () {
  325.     # returns what symlink in $1 actually points to
  326.     perl -e '$l = shift; exit 1 unless -l $l; $r = readlink $l; exit 1 unless $r; print "$r\n"' "$1"
  327.   }
  328. fi
  329.  
  330. check_symlink () {
  331.   # syntax: check_symlink symlink
  332.   #
  333.   # See if specified symlink points where it is supposed to.  Return 0 if it
  334.   # does, and 1 if it does not.
  335.   #
  336.   # Primarily used by check_symlinks_and_warn() and check_symlinks_and_bomb().
  337.  
  338.   local symlink
  339.  
  340.   # validate arguments
  341.   if [ $# -ne 1 ]; then
  342.     usage_error "check_symlink() called with wrong number of arguments;" \
  343.                 "expected 1, got $#"
  344.     exit $SHELL_LIB_USAGE_ERROR
  345.   fi
  346.  
  347.   symlink="$1"
  348.  
  349.   if [ "$(maplink "$symlink")" = "$(readlink "$symlink")" ]; then
  350.     return 0
  351.   else
  352.     return 1
  353.   fi
  354. }
  355.  
  356. check_symlinks_and_warn () {
  357.   # syntax: check_symlinks_and_warn symlink ...
  358.   #
  359.   # For each argument, check for symlink sanity, and warn if it isn't sane.
  360.   #
  361.   # Call this function from a preinst script in the event $1 is "upgrade" or
  362.   # "install".
  363.  
  364.   local errmsg symlink
  365.  
  366.   # validate arguments
  367.   if [ $# -lt 1 ]; then
  368.     usage_error "check_symlinks_and_warn() called with wrong number of" \
  369.                 "arguments; expected at least 1, got $#"
  370.     exit $SHELL_LIB_USAGE_ERROR
  371.   fi
  372.  
  373.   while [ -n "$1" ]; do
  374.     symlink="$1"
  375.     if [ -L "$symlink" ]; then
  376.       if ! check_symlink "$symlink"; then
  377.         observe "$symlink symbolic link points to wrong location" \
  378.                 "$(readlink "$symlink"); removing"
  379.         rm "$symlink"
  380.       fi
  381.     elif [ -e "$symlink" ]; then
  382.       errmsg="$symlink exists and is not a symbolic link; this package cannot"
  383.       errmsg="$errmsg be installed until this"
  384.       if [ -f "$symlink" ]; then
  385.         errmsg="$errmsg file"
  386.       elif [ -d "$symlink" ]; then
  387.         errmsg="$errmsg directory"
  388.       else
  389.         errmsg="$errmsg thing"
  390.       fi
  391.       errmsg="$errmsg is removed"
  392.       die "$errmsg"
  393.     fi
  394.     shift
  395.   done
  396. }
  397.  
  398. check_symlinks_and_bomb () {
  399.   # syntax: check_symlinks_and_bomb symlink ...
  400.   #
  401.   # For each argument, check for symlink sanity, and bomb if it isn't sane.
  402.   #
  403.   # Call this function from a postinst script.
  404.  
  405.   local problem symlink
  406.  
  407.   # validate arguments
  408.   if [ $# -lt 1 ]; then
  409.     usage_error "check_symlinks_and_bomb() called with wrong number of"
  410.                 "arguments; expected at least 1, got $#"
  411.     exit $SHELL_LIB_USAGE_ERROR
  412.   fi
  413.  
  414.   while [ -n "$1" ]; do
  415.     problem=
  416.     symlink="$1"
  417.     if [ -L "$symlink" ]; then
  418.       if ! check_symlink "$symlink"; then
  419.         problem=yes
  420.         warn "$symlink symbolic link points to wrong location" \
  421.              "$(readlink "$symlink")"
  422.       fi
  423.     elif [ -e "$symlink" ]; then
  424.       problem=yes
  425.       warn "$symlink is not a symbolic link"
  426.     else
  427.       problem=yes
  428.       warn "$symlink symbolic link does not exist"
  429.     fi
  430.     if [ -n "$problem" ]; then
  431.       analyze_path "$symlink" "$(readlink "$symlink")"
  432.       find_culprits "$symlink"
  433.       die "bad symbolic links on system"
  434.     fi
  435.     shift
  436.   done
  437. }
  438.  
  439. font_update () {
  440.   # run $UPDATECMDS in $FONTDIRS
  441.  
  442.   local dir cmd shortcmd x_font_dir_prefix
  443.  
  444.   x_font_dir_prefix="/usr/share/fonts/X11"
  445.  
  446.   if [ -z "$UPDATECMDS" ]; then
  447.     usage_error "font_update() called but \$UPDATECMDS not set"
  448.   fi
  449.   if [ -z "$FONTDIRS" ]; then
  450.     usage_error "font_update() called but \$FONTDIRS not set"
  451.   fi
  452.  
  453.   reject_unlikely_path_chars "$UPDATECMDS"
  454.   reject_unlikely_path_chars "$FONTDIRS"
  455.  
  456.   for dir in $FONTDIRS; do
  457.     if [ -d "$x_font_dir_prefix/$dir" ]; then
  458.       for cmd in $UPDATECMDS; do
  459.         if which "$cmd" > /dev/null 2>&1; then
  460.           shortcmd=${cmd##*/}
  461.           observe "running $shortcmd in $dir font directory"
  462.       cmd_opts=
  463.           if [ "$shortcmd" = "update-fonts-alias" ]; then
  464.             cmd_opts=--x11r7-layout
  465.           fi
  466.           if [ "$shortcmd" = "update-fonts-dir" ]; then
  467.             cmd_opts=--x11r7-layout
  468.           fi
  469.           if [ "$shortcmd" = "update-fonts-scale" ]; then
  470.             cmd_opts=--x11r7-layout
  471.           fi
  472.           $cmd $cmd_opts $dir || warn "$cmd $cmd_opts $dir" \
  473.                               "failed; font directory data may not" \
  474.                               "be up to date"
  475.         else
  476.           warn "$cmd not found; not updating corresponding $dir font" \
  477.                "directory data"
  478.         fi
  479.       done
  480.     else
  481.       warn "$dir is not a directory; not updating font directory data"
  482.     fi
  483.   done
  484. }
  485.  
  486. remove_conffile_prepare () {
  487.   # syntax: remove_conffile_prepare filename official_md5sum ...
  488.   #
  489.   # Check a conffile "filename" against a list of canonical MD5 checksums.
  490.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  491.   # operands provided, then prepare the conffile for removal from the system.
  492.   # We defer actual deletion until the package is configured so that we can
  493.   # roll this operation back if package installation fails.
  494.   #
  495.   # Call this function from a preinst script in the event $1 is "upgrade" or
  496.   # "install" and verify $2 to ensure the package is being upgraded from a
  497.   # version (or installed over a version removed-but-not-purged) prior to the
  498.   # one in which the conffile was obsoleted.
  499.  
  500.   local conffile current_checksum
  501.  
  502.   # validate arguments
  503.   if [ $# -lt 2 ]; then
  504.     usage_error "remove_conffile_prepare() called with wrong number of" \
  505.                 "arguments; expected at least 2, got $#"
  506.     exit $SHELL_LIB_USAGE_ERROR
  507.   fi
  508.  
  509.   conffile="$1"
  510.   shift
  511.  
  512.   # does the conffile even exist?
  513.   if [ -e "$conffile" ]; then
  514.     # calculate its checksum
  515.     current_checksum=$(md5sum < "$conffile" | sed 's/[[:space:]].*//')
  516.     # compare it to each supplied checksum
  517.     while [ -n "$1" ]; do
  518.       if [ "$current_checksum" = "$1" ]; then
  519.         # we found a match; move the confffile and stop looking
  520.         observe "preparing obsolete conffile $conffile for removal"
  521.         mv "$conffile" "$conffile.$THIS_PACKAGE-tmp"
  522.         break
  523.       fi
  524.       shift
  525.     done
  526.   fi
  527. }
  528.  
  529. remove_conffile_lookup () {
  530.   # syntax: remove_conffile_lookup package filename
  531.   #
  532.   # Lookup the md5sum of a conffile in dpkg's database, and prepare for removal
  533.   # if it matches the actual file's md5sum.
  534.   #
  535.   # Call this function when you would call remove_conffile_prepare but only
  536.   # want to check against dpkg's status database instead of known checksums.
  537.  
  538.   local package conffile old_md5sum
  539.  
  540.   # validate arguments
  541.   if [ $# -ne 2 ]; then
  542.     usage_error "remove_conffile_lookup() called with wrong number of" \
  543.                 "arguments; expected 1, got $#"
  544.     exit $SHELL_LIB_USAGE_ERROR
  545.   fi
  546.  
  547.   package="$1"
  548.   conffile="$2"
  549.  
  550.   if ! [ -e "$conffile" ]; then
  551.     return
  552.   fi
  553.   old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$package" | \
  554.     awk '{ if (match($0, "^ '"$conffile"' ")) print $2}')"
  555.   if [ -n "$old_md5sum" ]; then
  556.     remove_conffile_prepare "$conffile" "$old_md5sum"
  557.   fi
  558. }
  559.  
  560. remove_conffile_commit () {
  561.   # syntax: remove_conffile_commit filename
  562.   #
  563.   # Complete the removal of a conffile "filename" that has become obsolete.
  564.   #
  565.   # Call this function from a postinst script after having used
  566.   # remove_conffile_prepare() in the preinst.
  567.  
  568.   local conffile
  569.  
  570.   # validate arguments
  571.   if [ $# -ne 1 ]; then
  572.     usage_error "remove_conffile_commit() called with wrong number of" \
  573.                 "arguments; expected 1, got $#"
  574.     exit $SHELL_LIB_USAGE_ERROR
  575.   fi
  576.  
  577.   conffile="$1"
  578.  
  579.   # if the temporary file created by remove_conffile_prepare() exists, remove it
  580.   if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
  581.     observe "committing removal of obsolete conffile $conffile"
  582.     rm "$conffile.$THIS_PACKAGE-tmp"
  583.   fi
  584. }
  585.  
  586. remove_conffile_rollback () {
  587.   # syntax: remove_conffile_rollback filename
  588.   #
  589.   # Roll back the removal of a conffile "filename".
  590.   #
  591.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  592.   # or "abort-install" is  after having used remove_conffile_prepare() in the
  593.   # preinst.
  594.  
  595.   local conffile
  596.  
  597.   # validate arguments
  598.   if [ $# -ne 1 ]; then
  599.     usage_error "remove_conffile_rollback() called with wrong number of" \
  600.                 "arguments; expected 1, got $#"
  601.     exit $SHELL_LIB_USAGE_ERROR
  602.   fi
  603.  
  604.   conffile="$1"
  605.  
  606.   # if the temporary file created by remove_conffile_prepare() exists, move it
  607.   # back
  608.   if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
  609.     observe "rolling back removal of obsolete conffile $conffile"
  610.     mv "$conffile.$THIS_PACKAGE-tmp" "$conffile"
  611.   fi
  612. }
  613.  
  614. replace_conffile_with_symlink_prepare () {
  615.   # syntax: replace_conffile_with_symlink_prepare oldfilename newfilename \
  616.   # official_md5sum ...
  617.   #
  618.   # Check a conffile "oldfilename" against a list of canonical MD5 checksums.
  619.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  620.   # operands provided, then prepare the conffile for removal from the system.
  621.   # We defer actual deletion until the package is configured so that we can
  622.   # roll this operation back if package installation fails. Otherwise copy it
  623.   # to newfilename and let dpkg handle it through conffiles mechanism.
  624.   #
  625.   # Call this function from a preinst script in the event $1 is "upgrade" or
  626.   # "install" and verify $2 to ensure the package is being upgraded from a
  627.   # version (or installed over a version removed-but-not-purged) prior to the
  628.   # one in which the conffile was obsoleted.
  629.  
  630.   local conffile current_checksum
  631.  
  632.   # validate arguments
  633.   if [ $# -lt 3 ]; then
  634.     usage_error "replace_conffile_with_symlink_prepare() called with wrong" \
  635.                 " number of arguments; expected at least 3, got $#"
  636.     exit $SHELL_LIB_USAGE_ERROR
  637.   fi
  638.  
  639.   oldconffile="$1"
  640.   shift
  641.   newconffile="$1"
  642.   shift
  643.  
  644.   remove_conffile_prepare "$_oldconffile" "$@"
  645.   # If $oldconffile still exists, then md5sums didn't match.
  646.   # Copy it to new one.
  647.   if [ -f "$oldconffile" ]; then
  648.     cp "$oldconffile" "$newconffile"
  649.   fi
  650.  
  651. }
  652.  
  653. replace_conffile_with_symlink_commit () {
  654.   # syntax: replace_conffile_with_symlink_commit oldfilename
  655.   #
  656.   # Complete the removal of a conffile "oldfilename" that has been
  657.   # replaced by a symlink.
  658.   #
  659.   # Call this function from a postinst script after having used
  660.   # replace_conffile_with_symlink_prepare() in the preinst.
  661.  
  662.   local conffile
  663.  
  664.   # validate arguments
  665.   if [ $# -ne 1 ]; then
  666.     usage_error "replace_conffile_with_symlink_commit() called with wrong" \
  667.                 "number of arguments; expected 1, got $#"
  668.     exit $SHELL_LIB_USAGE_ERROR
  669.   fi
  670.  
  671.   conffile="$1"
  672.  
  673.   remove_conffile_commit "$conffile"
  674. }
  675.  
  676. replace_conffile_with_symlink_rollback () {
  677.   # syntax: replace_conffile_with_symlink_rollback oldfilename newfilename
  678.   #
  679.   # Roll back the replacing of a conffile "oldfilename" with symlink to
  680.   # "newfilename".
  681.   #
  682.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  683.   # or "abort-install" and verify $2 to ensure the package failed to upgrade
  684.   # from a version (or install over a version removed-but-not-purged) prior
  685.   # to the one in which the conffile was obsoleted.
  686.   # You should have  used replace_conffile_with_symlink_prepare() in the
  687.   # preinst.
  688.  
  689.   local conffile
  690.  
  691.   # validate arguments
  692.   if [ $# -ne 2 ]; then
  693.     usage_error "replace_conffile_with_symlink_rollback() called with wrong" \
  694.                 "number of arguments; expected 2, got $#"
  695.     exit $SHELL_LIB_USAGE_ERROR
  696.   fi
  697.  
  698.   oldconffile="$1"
  699.   newconffile="$2"
  700.  
  701.   remove_conffile_rollback "$_oldconffile"
  702.   if [ -f "$newconffile" ]; then
  703.     rm "$newconffile"
  704.   fi
  705. }
  706.  
  707. run () {
  708.   # syntax: run command [ argument ... ]
  709.   #
  710.   # Run specified command with optional arguments and report its exit status.
  711.   # Useful for commands whose exit status may be nonzero, but still acceptable,
  712.   # or commands whose failure is not fatal to us.
  713.   #
  714.   # NOTE: Do *not* use this function with db_get or db_metaget commands; in
  715.   # those cases the return value of the debconf command *must* be checked
  716.   # before the string returned by debconf is used for anything.
  717.  
  718.   local retval
  719.  
  720.   # validate arguments
  721.   if [ $# -lt 1 ]; then
  722.     usage_error "run() called with wrong number of arguments; expected at" \
  723.                 "least 1, got $#"
  724.     exit $SHELL_LIB_USAGE_ERROR
  725.   fi
  726.  
  727.   "$@" || retval=$?
  728.  
  729.   if [ ${retval:-0} -ne 0 ]; then
  730.     observe "command \"$*\" exited with status $retval"
  731.   fi
  732. }
  733.  
  734. make_symlink_sane () {
  735.   # syntax: make_symlink_sane symlink target
  736.   #
  737.   # Ensure that the symbolic link symlink exists, and points to target.
  738.   #
  739.   # If symlink does not exist, create it and point it at target.
  740.   #
  741.   # If symlink exists but is not a symbolic link, back it up.
  742.   #
  743.   # If symlink exists, is a symbolic link, but points to the wrong location, fix
  744.   # it.
  745.   #
  746.   # If symlink exists, is a symbolic link, and already points to target, do
  747.   # nothing.
  748.   #
  749.   # This function wouldn't be needed if ln had an -I, --idempotent option.
  750.  
  751.   # Validate arguments.
  752.   if [ $# -ne 2 ]; then
  753.     usage_error "make_symlink_sane() called with wrong number of arguments;" \
  754.       "expected 2, got $#"
  755.     exit $SHELL_LIB_USAGE_ERROR
  756.   fi
  757.  
  758.   # We could just use the positional parameters as-is, but that makes things
  759.   # harder to follow.
  760.   local symlink target
  761.  
  762.   symlink="$1"
  763.   target="$2"
  764.  
  765.   if [ -L "$symlink" ] && [ "$(readlink "$symlink")" = "$target" ]; then
  766.       observe "link from $symlink to $target already exists"
  767.   else
  768.     observe "creating symbolic link from $symlink to $target"
  769.     mkdir -p "${target%/*}" "${symlink%/*}"
  770.     ln -s -b -S ".dpkg-old" "$target" "$symlink"
  771.   fi
  772. }
  773.  
  774. migrate_dir_to_symlink () {
  775.   # syntax: migrate_dir_to_symlink old_location new_location
  776.   #
  777.   # Per Debian Policy section 6.5.4, "A directory will never be replaced by a
  778.   # symbolic link to a directory or vice versa; instead, the existing state
  779.   # (symlink or not) will be left alone and dpkg will follow the symlink if
  780.   # there is one."
  781.   #
  782.   # We have to do it ourselves.
  783.   #
  784.   # This function moves the contents of old_location, a directory, into
  785.   # new_location, a directory, then makes old_location a symbolic link to
  786.   # new_location.
  787.   #
  788.   # old_location need not exist, but if it does, it must be a directory (or a
  789.   # symlink to a directory).  If it is not, it is backed up.  If new_location
  790.   # exists already and is not a directory, it is backed up.
  791.   #
  792.   # This function should be called from a package's preinst so that other
  793.   # packages unpacked after this one --- but before this package's postinst runs
  794.   # --- are unpacked into new_location even if their payloads contain
  795.   # old_location filespecs.
  796.  
  797.   # Validate arguments.
  798.   if [ $# -ne 2 ]; then
  799.     usage_error "migrate_dir_to_symlink() called with wrong number of"
  800.                 "arguments; expected 2, got $#"
  801.     exit $SHELL_LIB_USAGE_ERROR
  802.   fi
  803.  
  804.   # We could just use the positional parameters as-is, but that makes things
  805.   # harder to follow.
  806.   local new old
  807.  
  808.   old="$1"
  809.   new="$2"
  810.  
  811.   # Is old location a symlink?
  812.   if [ -L "$old" ]; then
  813.     # Does it already point to new location?
  814.     if [ "$(readlink "$old")" = "$new" ]; then
  815.       # Nothing to do; migration has already been done.
  816.       observe "migration of $old to $new already done"
  817.       return 0
  818.     else
  819.       # Back it up.
  820.       warn "backing up symbolic link $old as $old.dpkg-old"
  821.       mv -b "$old" "$old.dpkg-old"
  822.     fi
  823.   fi
  824.  
  825.   # Does old location exist, but is not a directory?
  826.   if [ -e "$old" ] && ! [ -d "$old" ]; then
  827.       # Back it up.
  828.       warn "backing up non-directory $old as $old.dpkg-old"
  829.       mv -b "$old" "$old.dpkg-old"
  830.   fi
  831.  
  832.   observe "migrating $old to $new"
  833.  
  834.   # Is new location a symlink?
  835.   if [ -L "$new" ]; then
  836.     # Does it point the wrong way, i.e., back to where we're migrating from?
  837.     if [ "$(readlink "$new")" = "$old" ]; then
  838.       # Get rid of it.
  839.       observe "removing symbolic link $new which points to $old"
  840.       rm "$new"
  841.     else
  842.       # Back it up.
  843.       warn "backing up symbolic link $new as $new.dpkg-old"
  844.       mv -b "$new" "$new.dpkg-old"
  845.     fi
  846.   fi
  847.  
  848.   # Does new location exist, but is not a directory?
  849.   if [ -e "$new" ] && ! [ -d "$new" ]; then
  850.     warn "backing up non-directory $new as $new.dpkg-old"
  851.     mv -b "$new" "$new.dpkg-old"
  852.   fi
  853.  
  854.   # Create new directory if it does not yet exist.
  855.   if ! [ -e "$new" ]; then
  856.     observe "creating $new"
  857.     mkdir -p "$new"
  858.   fi
  859.  
  860.   # Copy files in old location to new location.  Back up any filenames that
  861.   # already exist in the new location with the extension ".dpkg-old".
  862.   observe "copying files from $old to $new"
  863.   if ! (cd "$old" && cp -a -b -S ".dpkg-old" . "$new"); then
  864.     die "error(s) encountered while copying files from $old to $new"
  865.   fi
  866.  
  867.   # Remove files at old location.
  868.   observe "removing $old"
  869.   rm -r "$old"
  870.  
  871.   # Create symlink from old location to new location.
  872.   make_symlink_sane "$old" "$new"
  873. }
  874.  
  875. # vim:set ai et sw=2 ts=2 tw=80:
  876.  
  877. # GOBSTOPPER: The X Strike Force shell library ends here.
  878.  
  879. # Automatically added by dh_installxfonts
  880. if [ -x "`which update-fonts-dir 2>/dev/null`" ]; then
  881. update-fonts-dir --x11r7-layout misc;update-fonts-alias misc
  882. fi
  883. # End automatically added section
  884.  
  885.  
  886. if [ "$1" = "abort-install" ] || [ "$1" = "abort-upgrade" ]; then
  887.     remove_conffile_rollback /etc/X11/fonts/X11R7/misc/xfonts-base.alias
  888. fi
  889.  
  890. if [ "$1" = "purge" ]; then
  891.     for DIR in /etc/X11/fonts/X11R7/misc /etc/X11/fonts/X11R7 \
  892.         /etc/X11/fonts/misc /etc/X11/fonts /etc/X11; do
  893.         rmdir $DIR 2>/dev/null || true
  894.     done
  895. fi
  896.  
  897. exit 0
  898.  
  899. # vim:set ai et sw=4 ts=4 tw=80:
  900.